846. 树的重心

846. 树的重心

给定一颗树,树中包含 n个结点(编号 1∼n)和 n−1条无向边。

请你找到树的重心,并输出将重心删除后,剩余各个连通块中点数的最大值。

重心定义:重心是指树中的一个结点,如果将这个点删除后,剩余各个连通块中点数的最大值最小,那么这个节点被称为树的重心。

输入格式

第一行包含整数 n,表示树的结点数。

接下来 n−1行,每行包含两个整数 a和 b,表示点 a和点 b之间存在一条边。

输出格式

输出一个整数 m,表示将重心删除后,剩余各个连通块中点数的最大值。

数据范围

1≤n≤105

输入样例

9

1 2

1 7

1 4

2 8

2 5

4 3

3 9

4 6

输出样例:

4

解题思路

以样例为例子

无1:3、1、4, max=4

无2:1、1、6, max=6

无7:8,max=8

无4:2、1、5,max=5

...

第一次寻找的是最大的每个连通的的最大值,第二次比较的是最大值中的最小值,因此本题目的样例的答案为4

cpp 复制代码
#include<iostream>
#include<algorithm>
#include<cstring>

using namespace std;

const int N = 1e5+10,M = 2*N;

int h[N],e[M],ne[M],idx;
bool st[N];
int n;
int ans=N;

void add(int a,int b){
    e[idx]=b,ne[idx]=h[a],h[a]=idx++;
}

int dfs(int u){
    st[u]=true;
    int size=0,sum=1;
    for(int i=h[u];~i;i=ne[i]){
        int j=e[i];
        if(st[j]) continue;
        int s=dfs(j);//一次探寻后的连通数量
        size = max(size,s);
        sum+=s;//以j节点的所有子路的点的数量
    }
    size=max(size,n-sum);//最大连通数量
    ans=min(ans,size);//最大连通数量的最小值
    
    return sum;
}

int main(){
    cin>>n;
    memset(h,-1,sizeof h);
    for(int i=0;i<n-1;i++){
        int a,b;
        cin>>a>>b;
        add(a,b),add(b,a);
    }
    dfs(1);
    cout<<ans<<endl;
    return 0;
}
相关推荐
hanlin037 小时前
刷题笔记:力扣第32题-最长有效括号
笔记·算法·leetcode
All for pursuit.8 小时前
【动态规划-21】312.戳气球
数据结构·c++·算法·leetcode·动态规划
碧海银沙音频科技研究院10 小时前
基于炬芯ATS3089X自研AEC声学回声消除算法
算法
通问AI10 小时前
在两台 Mac Studio 上跑 800B 模型:MLX + RDMA over Thunderbolt 实测与四道门选型法
算法
ZywOo62310 小时前
《算法竞赛进阶指南》0x03 前缀和与差分
算法
Scintilla_y10 小时前
DAY2 滑动窗口
算法·leetcode·散列表
lvwangshu10 小时前
笛卡尔树
算法·图论
026d2311 小时前
状态信号只知“其然”不知“其所以然”:变工况机械故障诊断的物理盲区
算法
姜鱼问生11 小时前
备份和服务器在同一台机器上,等于没备份
算法·架构
姜鱼问生11 小时前
别再 chmod 777 了,用 ACL 给它开一扇窗
后端·算法·架构